summaryrefslogtreecommitdiff
path: root/tests/df
diff options
context:
space:
mode:
authorBernhard Voelker <mail@bernhard-voelker.de>2012-08-04 01:09:22 +0200
committerPádraig Brady <P@draigBrady.com>2012-08-04 17:30:07 +0100
commit3b8139e85f3a96dfefaba94d0764135376135ae8 (patch)
tree428f256cf133859d6429eadf7a504c620609bc8e /tests/df
parentcbd1cffa3eb9e6e5ca82ec67d3c4211a019dd1ed (diff)
downloadcoreutils-3b8139e85f3a96dfefaba94d0764135376135ae8.tar.xz
df: fix exit code and error messages with --total
When the combination of the file system options with given files or devices does not lead to output, "df --total" would exit successfully although it should not. Examples: $ df --total --type=xfs / # when / is not an XFS file system $ df --total --local -t nfs DIR # nfs is remote per se ... $ df --total -t qwerty /dev/sdb5 # typo in file system type Furthermore, "df --total" would not print the error message "no file systems processed" when the file argument does not exist or is otherwise not accessible. Example: $ df --total __not_exist__ These 2 bugs are present since --total was added by commit v6.12-166-gea2887b. * src/df.c (get_dev): Do not set file_systems_processed to true when force_fsu is true, i.e. when the row for the "total" line is processed. (main): Don't print totals unless we've processed a file system. Also only print the "no FS processed" message if there was no preceding diagnostic. * tests/df/total-unprocessed: Add a new test. * tests/Makefile.am: Reference the new test. * NEWS: Mention the fix. Improved-by: Jim Meyering
Diffstat (limited to 'tests/df')
-rwxr-xr-xtests/df/total-unprocessed41
1 files changed, 41 insertions, 0 deletions
diff --git a/tests/df/total-unprocessed b/tests/df/total-unprocessed
new file mode 100755
index 000000000..9742591f7
--- /dev/null
+++ b/tests/df/total-unprocessed
@@ -0,0 +1,41 @@
+#!/bin/sh
+# Ensure that df exits non-Zero and writes an error message when
+# --total is used but no file system has been processed.
+
+# Copyright (C) 2012 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+. "${srcdir=.}/init.sh"; path_prepend_ ../src
+print_ver_ df
+
+cat <<\EOF > exp || framework_failure_
+df: no file systems processed
+EOF
+
+# The following simply finds no match for the combination
+# of the options --local and FS-type nfs together with the
+# argument ".". It must exit non-Zero nonetheless.
+df --local -t nfs --total "." 2>out && fail=1
+compare exp out || fail=1
+
+cat <<\EOF > exp || framework_failure_
+df: '_does_not_exist_': No such file or directory
+EOF
+
+# Ensure that df writes the error message also in the following case.
+df --total _does_not_exist_ 2>out && fail=1
+compare exp out || fail=1
+
+Exit $fail